> ## Documentation Index
> Fetch the complete documentation index at: https://openworklabs.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Import GitHub plugin MCPs

> Creates/reuses Den External MCP Connections for selected remote MCP servers from a public GitHub plugin URL and publishes one marketplace plugin that references them.



## OpenAPI

````yaml /openapi.json post /v1/plugins/import-mcps-from-github-url
openapi: 3.1.0
info:
  title: Den API
  description: >-
    OpenAPI spec for the Den control plane API.


    Authentication:

    - Use `Authorization: Bearer <session-token>` for user-authenticated routes
    that require a Den session.

    - Use `x-api-key: <den-api-key>` for API-key-authenticated routes that
    accept organization API keys.

    - Public routes like health and documentation do not require authentication.


    Swagger tip: use the security schemes in the Authorize dialog to set either
    `bearerAuth` or `denApiKey` before trying protected endpoints.
  version: dev
servers: []
security: []
tags:
  - name: System
    description: Service health and operational routes.
  - name: Organizations
    description: Top-level organization creation and context routes.
  - name: Invitations
    description: Invitation preview, acceptance, creation, and cancellation routes.
  - name: API Keys
    description: Organization API key management routes.
  - name: SCIM
    description: Organization SCIM connector management routes.
  - name: SSO
    description: Organization single sign-on connector management routes.
  - name: Members
    description: Organization member management routes.
  - name: Roles
    description: Organization custom role management routes.
  - name: Teams
    description: Organization team management routes.
  - name: Templates
    description: Organization shared template routes.
  - name: LLM Providers
    description: Organization LLM provider catalog, configuration, and access routes.
  - name: Skills
    description: Organization skill authoring and sharing routes.
  - name: Skill Hubs
    description: Organization skill hub management and access routes.
  - name: Workers
    description: Worker lifecycle, billing, and runtime routes.
  - name: Worker Runtime
    description: Worker runtime inspection and upgrade routes.
  - name: Worker Activity
    description: Worker heartbeat and activity reporting routes.
  - name: Telemetry
    description: Telemetry event ingestion and adoption analytics.
  - name: Admin
    description: Administrative reporting routes.
  - name: Users
    description: Current user and membership routes.
  - name: Bootstrap
    description: Agent-first provisional workspace setup routes.
paths:
  /v1/plugins/import-mcps-from-github-url:
    post:
      tags:
        - GitHub
      summary: Import GitHub plugin MCPs
      description: >-
        Creates/reuses Den External MCP Connections for selected remote MCP
        servers from a public GitHub plugin URL and publishes one marketplace
        plugin that references them.
      operationId: postV1PluginsImportMcpsFromGithubUrl
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                githubUrl:
                  type: string
                  maxLength: 2048
                  format: uri
                access:
                  type: object
                  properties:
                    orgWide:
                      default: true
                      type: boolean
                    memberIds:
                      maxItems: 200
                      type: array
                      items:
                        description: >-
                          Den TypeID with 'om_' prefix and a 26-character base32
                          suffix.
                        format: typeid
                        type: string
                        minLength: 29
                        maxLength: 29
                        pattern: ^om_.*
                    teamIds:
                      maxItems: 200
                      type: array
                      items:
                        description: >-
                          Den TypeID with 'tem_' prefix and a 26-character
                          base32 suffix.
                        format: typeid
                        type: string
                        minLength: 30
                        maxLength: 30
                        pattern: ^tem_.*
                authType:
                  default: oauth
                  type: string
                  enum:
                    - oauth
                    - none
                credentialMode:
                  default: per_member
                  type: string
                  enum:
                    - shared
                    - per_member
                marketplaceId:
                  description: >-
                    Den TypeID with 'mkt_' prefix and a 26-character base32
                    suffix.
                  format: typeid
                  type: string
                  minLength: 30
                  maxLength: 30
                  pattern: ^mkt_.*
                selectedSkillKeys:
                  maxItems: 200
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 1024
                selectedServerKeys:
                  maxItems: 200
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 1024
                selectedServerNames:
                  maxItems: 200
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 255
              required:
                - githubUrl
                - marketplaceId
      responses:
        '200':
          description: GitHub plugin MCPs imported successfully.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GithubPluginMcpImportResponse'
        '400':
          description: The GitHub plugin MCP import request was invalid.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InvalidRequestError'
        '401':
          description: The caller must be signed in to import plugin MCPs.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthorizedError'
        '403':
          description: The caller lacks permission to import plugin MCPs.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenError'
        '404':
          description: The GitHub plugin path or marketplace could not be found.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFoundError'
components:
  schemas:
    GithubPluginMcpImportResponse:
      type: object
      properties:
        ok:
          type: boolean
          const: true
        item:
          type: object
          properties:
            imported:
              type: array
              items:
                type: object
                properties:
                  connectionId:
                    type: string
                  name:
                    type: string
                  url:
                    type: string
                required:
                  - connectionId
                  - name
                  - url
            importedSkills:
              type: array
              items:
                type: object
                properties:
                  name:
                    type: string
                  skillId:
                    description: >-
                      Den TypeID with 'skl_' prefix and a 26-character base32
                      suffix.
                    format: typeid
                    type: string
                    minLength: 30
                    maxLength: 30
                    pattern: ^skl_.*
                  sourcePath:
                    type: string
                required:
                  - name
                  - skillId
                  - sourcePath
            marketplaceId:
              description: Den TypeID with 'mkt_' prefix and a 26-character base32 suffix.
              format: typeid
              type: string
              minLength: 30
              maxLength: 30
              pattern: ^mkt_.*
            plugin:
              $ref: '#/components/schemas/PluginArchPlugin'
            skipped:
              type: array
              items:
                type: object
                properties:
                  name:
                    type: string
                  reason:
                    type: string
                    enum:
                      - missing_url
                      - local_unsupported
                      - invalid_url
                      - unsupported_auth
                required:
                  - name
                  - reason
            skippedSkills:
              type: array
              items:
                type: object
                properties:
                  name:
                    type: string
                  reason:
                    type: string
                    enum:
                      - invalid_skill
                  sourcePath:
                    type: string
                required:
                  - name
                  - reason
                  - sourcePath
          required:
            - imported
            - importedSkills
            - marketplaceId
            - plugin
            - skipped
            - skippedSkills
      required:
        - ok
        - item
    InvalidRequestError:
      type: object
      properties:
        error:
          type: string
          const: invalid_request
        details:
          type: array
          items:
            type: object
            properties:
              message:
                type: string
              path:
                type: array
                items:
                  anyOf:
                    - type: string
                    - type: number
            required:
              - message
            additionalProperties: {}
      required:
        - error
        - details
    UnauthorizedError:
      type: object
      properties:
        error:
          type: string
          const: unauthorized
      required:
        - error
    ForbiddenError:
      type: object
      properties:
        error:
          type: string
          enum:
            - forbidden
            - reauth
        reason:
          type: string
        message:
          type: string
      required:
        - error
    NotFoundError:
      type: object
      properties:
        error:
          type: string
        message:
          type: string
      required:
        - error
    PluginArchPlugin:
      type: object
      properties:
        id:
          description: Den TypeID with 'plg_' prefix and a 26-character base32 suffix.
          format: typeid
          type: string
          minLength: 30
          maxLength: 30
          pattern: ^plg_.*
        organizationId:
          description: Den TypeID with 'org_' prefix and a 26-character base32 suffix.
          format: typeid
          type: string
          minLength: 30
          maxLength: 30
          pattern: ^org_.*
        name:
          type: string
          minLength: 1
          maxLength: 255
        description:
          anyOf:
            - type: string
              minLength: 1
            - type: 'null'
        status:
          type: string
          enum:
            - active
            - inactive
            - deleted
            - archived
        createdByOrgMembershipId:
          description: Den TypeID with 'om_' prefix and a 26-character base32 suffix.
          format: typeid
          type: string
          minLength: 29
          maxLength: 29
          pattern: ^om_.*
        createdAt:
          type: string
          format: date-time
          pattern: >-
            ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
        updatedAt:
          type: string
          format: date-time
          pattern: >-
            ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
        deletedAt:
          anyOf:
            - type: string
              format: date-time
              pattern: >-
                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
            - type: 'null'
        memberCount:
          type: integer
          minimum: 0
          maximum: 9007199254740991
        marketplaces:
          type: array
          items:
            type: object
            properties:
              id:
                description: >-
                  Den TypeID with 'mkt_' prefix and a 26-character base32
                  suffix.
                format: typeid
                type: string
                minLength: 30
                maxLength: 30
                pattern: ^mkt_.*
              name:
                type: string
                minLength: 1
                maxLength: 255
            required:
              - id
              - name
        extension:
          anyOf:
            - $ref: '#/components/schemas/PluginArchExtensionProjection'
            - type: 'null'
      required:
        - id
        - organizationId
        - name
        - description
        - status
        - createdByOrgMembershipId
        - createdAt
        - updatedAt
        - deletedAt
    PluginArchExtensionProjection:
      type: object
      properties:
        id:
          description: Den TypeID with 'plg_' prefix and a 26-character base32 suffix.
          format: typeid
          type: string
          minLength: 30
          maxLength: 30
          pattern: ^plg_.*
        name:
          type: string
          minLength: 1
          maxLength: 255
        description:
          anyOf:
            - type: string
              minLength: 1
            - type: 'null'
        sourceFormat:
          type: string
          enum:
            - openwork-builtin
            - openwork-extension-manifest
            - claude-plugin
            - opencode-plugin
            - mcp-directory
            - manual
        manifest:
          anyOf:
            - $ref: '#/components/schemas/OpenWorkExtensionManifest'
            - type: 'null'
      required:
        - id
        - name
        - description
        - sourceFormat
        - manifest
    OpenWorkExtensionManifest:
      type: object
      properties:
        schemaVersion:
          type: number
          const: 1
        id:
          type: string
          minLength: 1
          maxLength: 255
        name:
          type: string
          minLength: 1
          maxLength: 255
        description:
          type: string
          minLength: 1
          maxLength: 2048
        source:
          type: object
          properties:
            format:
              type: string
              enum:
                - openwork-builtin
                - openwork-extension-manifest
                - claude-plugin
                - opencode-plugin
                - mcp-directory
                - manual
            trusted:
              type: boolean
            origin:
              type: string
              enum:
                - builtin
                - den
                - workspace
                - local
            reference:
              type: string
              minLength: 1
              maxLength: 512
          required:
            - format
            - trusted
        resources:
          type: array
          items:
            type: object
            properties: {}
            additionalProperties: {}
        contributions:
          type: array
          items:
            type: object
            properties: {}
            additionalProperties: {}
        setup:
          type: object
          properties: {}
          additionalProperties: {}
        lifecycle:
          type: object
          properties: {}
          additionalProperties: {}
      required:
        - schemaVersion
        - id
        - name
        - description
        - source
        - resources
      additionalProperties: {}

````